/*****************************************************************************
' Ce module contient contient les sous-programmes les plus techniques de l'application
'    (placement aléatoire de bateaux, vérification de non croisement...).
' Attention : son code ne doit pas être modifié en principe !
*****************************************************************************/

function placer_aleatoire(taille, legende) {
    OK = false;
    while (!OK) {
        direction = Hasard(2);
        lig_debut = Hasard(10);
        col_debut = Hasard(10);
        if (direction == 1) {
            OK = tester_horizontal(lig_debut, col_debut, taille);
		}
        else {
            OK = tester_vertical(lig_debut, col_debut, taille);
        }
    }
    if (direction == 1) {
        placer_horizontal(lig_debut, col_debut, taille, legende);
	}
    else {
        placer_vertical(lig_debut, col_debut, taille, legende);
    }
}

function tester_horizontal(lig_debut, col_debut, taille) {
    col_fin = col_debut + taille - 1;
    if (col_fin > 10) {
        return false;
    }
    OK = true;
	for(col=col_debut; col<=col_fin; col++) {
        if (modele(lig_debut, col).value != "" || estRouge(modele(lig_debut, col))) {
            OK = false;
        }
    }
    return OK;
}

function placer_horizontal(lig_debut, col_debut, taille, legende) {
    col_fin = col_debut + taille - 1;
	for(col=col_debut; col<=col_fin; col++) {
        modele(lig_debut, col).value = legende;
    }
    // -- rectangle englobant du bateau
    lig1 = lig_debut - 1; // on interdira aussi la ligne au dessus du bateau
    if (lig_debut == 1) {
        lig1 = 1;
    }
    lig2 = lig_debut + 1; // on interdira aussi la ligne au dessous du bateau
    if (lig_debut == 10) {
        lig2 = 10;
    }
    col1 = col_debut - 1; // on interdira aussi la colonne à gauche du bateau
    if (col_debut == 1) {
        col1 = 1;
    }
    col2 = col_fin + 1; // on interdira aussi la colonne à droite du bateau
    if (col_fin == 10) {
        col2 = 10;
    }
	for(lig=lig1; lig<=lig2; lig++) {
		for(col=col1; col<=col2; col++) {
            mettreEnRouge(modele(lig, col));
        }
    }
}

function tester_vertical(lig_debut, col_debut, taille) {
    lig_fin = lig_debut + taille - 1;
    if (lig_fin > 10) {
        return false;
    }
    OK = true;
	for(lig=lig_debut; lig<=lig_fin; lig++) {
        if (modele(lig, col_debut).value != "" || estRouge(modele(lig, col_debut))) {
            OK = false;
        }
    }
    return OK;
}

function placer_vertical(lig_debut, col_debut, taille, legende) {
    lig_fin = lig_debut + taille - 1;
	for(lig=lig_debut; lig<=lig_fin; lig++) {
        modele(lig, col_debut).value = legende;
    }
    //-- rectangle englobant du bateau
    lig1 = lig_debut - 1; // on interdira aussi la ligne au dessus du bateau
    if (lig_debut == 1) {
        lig1 = 1;
    }
    lig2 = lig_fin + 1; // on interdira aussi la ligne au dessous du bateau
    if (lig_fin == 10) {
        lig2 = 10;
    }
    col1 = col_debut - 1; // on interdira aussi la colonne à gauche du bateau
    if (col_debut == 1) {
        col1 = 1;
    }
    col2 = col_debut + 1; // on interdira aussi la colonne à droite du bateau
    if (col_debut == 10) {
        col2 = 10;
    }
	for(lig=lig1; lig<=lig2; lig++) {
		for(col=col1; col<=col2; col++) {
            mettreEnRouge(modele(lig, col));
        }
    }
}

